/// -*- tab-width: 4; Mode: C++; c-basic-offset: 4; indent-tabs-mode: nil -*-
#ifndef __Dads_H__
#define __Dads_H__


#include <AP_HAL/AP_HAL.h>
#include <Filter/AverageFilter.h>
#include <AP_HAL/Device.h>

#include <AP_HAL/Semaphores.h>

#define DADS_ADDR 0x48

class Dads
{
public:
    static Dads create() { return Dads{}; }
    //Dads(void);
    
    /* I2C_Sensors public interface: */
    bool    init(void);
	bool    read(void);
    uint8_t resultados(void){return _results;} //Result from the sensor
    bool    healthy(void){return _healthy;} //is the sensor working?

	

    AP_HAL::OwnPtr<AP_HAL::Device> _dev;

private:
    Dads();
    uint8_t			_results;   //result from the I2C
	bool			_healthy;   //we have good data
    uint16_t        _k[5];      //I am not using it in this moment, id for calibrating
};

#endif // __Dads_I2C_SENSORS_H__
