#include <AP_BoardConfig/AP_BoardConfig.h>
#include <AP_HAL/AP_HAL.h>
#include <Dads/Dads.h>

const AP_HAL::HAL &hal = AP_HAL::get_HAL();

static uint32_t timer;
static uint8_t counter;
static AP_BoardConfig board_config = AP_BoardConfig::create();
static bool inicio;
static bool medio;


static Dads sensor = Dads::create();

void setup();
void loop();

void setup()
{
	hal.console->printf("Prueba1\n");
	board_config.init();
	hal.scheduler->delay(1000);
	timer = AP_HAL::micros();
	inicio=sensor.init();
}

void loop()
{
	if (!hal.console->is_initialized()) {
		return;
	}
	
	// run accumulate() at 50Hz and update() at 10Hz
	if ((AP_HAL::micros() - timer) > 200 * 1000UL) {
		timer = AP_HAL::micros();
		if (counter++ < 15) {
		    return;
		}
		medio=sensor.read();
		uint8_t temp = sensor.resultados();
        	counter = 0;
        	hal.console->printf("Test: ");
		hal.console->printf(" %s  -", inicio?"true":"false");
		hal.console->printf(" %s  -", medio?"true":"false");
		//hal.console->printf(" %u  -",timer);
		hal.console->printf(" %u  -",temp);
	
		hal.console->println();
	} 
	else {
		hal.scheduler->delay(1);
	}
}

AP_HAL_MAIN();
