// Wire Slave Sensor Sender
// by James Overington

// Sends data from 6 virtual sensors for reciept by suitably modified ArduXXX code on APM 
// Created 20 March 2014
// This example code is in the public domain.

#include <Wire.h>
#include "Virtual_Sensor.h"

Sensor sensor;
uint8_t data;

void setup()
{
  randomSeed(analogRead(0));
  Serial.begin(9600);  
  //Set sensor types:
  sensor.setType(SINE);
 
  Wire.begin(0x48);                // join i2c bus with address 0x48 (0x48 arbitarily selected but must match setting in ArduXXX code and not conflict with any other device on the bus)
  Wire.onRequest(requestEvent); // register event
}

void loop()
{
  data=sensor.read();
  Serial. print("Sensor : ");
  Serial. println(data);
}

// function that executes whenever data is requested by master
// this function is registered as an event, see setup()
void requestEvent()
{
  Wire.write((uint8_t *)&data,sizeof(data)); // respond with message of 24 bytes
}                                   // as expected by master
